package com.zsc.edu.dify.modules.dify.service.Impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.zsc.edu.dify.exception.ConstraintException;
import com.zsc.edu.dify.modules.dify.entity.AppEntity;
import com.zsc.edu.dify.modules.dify.mapper.AppEntityMapper;
import com.zsc.edu.dify.modules.dify.repo.AppEntityRepository;
import com.zsc.edu.dify.modules.dify.service.DifyServerService;
import io.github.guoshiqiufeng.dify.server.DifyServer;
import io.github.guoshiqiufeng.dify.server.dto.response.ApiKeyResponseVO;
import io.github.guoshiqiufeng.dify.server.dto.response.AppsResponseVO;
import jakarta.annotation.Resource;
import lombok.AllArgsConstructor;
import org.springframework.stereotype.Service;

import java.util.*;

/**
 * @author zhuang
 */
@AllArgsConstructor
@Service
public class DifyServerServiceImpl extends ServiceImpl<AppEntityRepository, AppEntity> implements DifyServerService {
    @Resource
    private AppEntityMapper appEntityMapper;
    @Resource
    private DifyServer difyServer;

    @Override
    public List<AppsResponseVO> getApps(String mode, String name) {
        return addApps(difyServer.apps(mode, name));
    }

    public List<AppsResponseVO> addApps(List<AppsResponseVO> appsResponseList) {
        for(AppsResponseVO appsResponse : appsResponseList){
            boolean isHave = baseMapper.exists(new QueryWrapper<AppEntity>().eq("id", appsResponse.getId()));
            if(!isHave){
                AppEntity appEntity = appEntityMapper.toEntity(appsResponse);
                baseMapper.insert(appEntity);
                List<ApiKeyResponseVO> apiKeyList =difyServer.getAppApiKey(appsResponse.getId());
                if (apiKeyList != null) {
                    difyServer.initAppApiKey(appsResponse.getId());
                    Optional<ApiKeyResponseVO> apiKeyResponseVO = apiKeyList.stream()
                            .filter(apiKey -> apiKey.getToken() != null)
                            .findFirst();
                    apiKeyResponseVO.ifPresent(apiKey -> appEntity.setApiKey(apiKey.getToken()));
                }
                baseMapper.updateById(appEntity);
            }else{
                baseMapper.updateById(appEntityMapper.toEntity(appsResponse));
            }

        }
        return appsResponseList;
    }

    @Override
    public boolean enabledApp(String id) {
        AppEntity appEntity = baseMapper.selectById(id);
        if(appEntity == null){
            throw new ConstraintException("应用不存在");
        }
        appEntity.setEnabled(!appEntity.isEnabled());
        baseMapper.updateById(appEntity);
        return true;
    }
}
